<style type="text/css" scoped="">
.page_ct{
  display: flex;
  margin-top: 30px;
  margin-bottom: 18px;
  justify-content: center;
}
.manage_pane_actions{
  display: flex;
}
.manage_pane_actions .action_btn{
  margin-left: 10px;
}
.product_brief{
  color: #3B3B3B;
  display: flex;
  align-items: center;
  font-weight: bold;

  padding-top: 16px;
  padding-bottom: 16px;
  padding-left: 10px;
}
.product_brief .product_title{
  font-size: 16px;
  line-height: 1;
}
.product_brief .product_product_sku_id{
  font-size: 12px;
  line-height: 1;
  margin-left: 18px;
}
</style>
<template>
  <div class="product_list pane_ct">

    <div class="back_nav_ct">
      <!-- <div class="back_arrow"></div> -->
      <router-link :to="{'name': 'admin_index'}" class="back_arrow">

      </router-link>
    </div>

    <div class="manage_pane_nav">
      <h2 class="manage_pane_nav_title">商品详情</h2>
      <div class="manage_pane_actions">
        <a href="javascript:;" class="action_btn" @click="visible('create_sku_code_form_config', true)">生成溯源码</a>
        <!-- <a href="javascript:;" class="action_btn" @click="visible('create_sku_code_form_config', true)">生成记录</a> -->
      </div>
    </div>

    <div class="product_brief">
      <div class="product_title">{{ goods_name }}</div>
      <div class="product_product_sku_id">商品编码: {{ goods_code }}</div>
    </div>

    <!-- <base_dialog></base_dialog> -->

    <div>
      <table class="base_table">
        <tr class="header">
          <td>
            <div class="small_gray_ft">
              时间
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              数量
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              起始
            </div>
          </td>
          <!-- <td>
            <div class="small_gray_ft">
              商品编码
            </div>
          </td> -->
          <td>
            <div class="small_gray_ft">
              操作
            </div>
          </td>
        </tr>

        <tr v-for="item, index in query_configs.data" :key="index">
          <td>
              {{ item.time }}
              <!-- <div class="img_ct" @click="show_img(index, true)">
                
              </div>
              <img_show_dialog v-if="item.show_img" @close="show_img(index, false)"></img_show_dialog> -->
          </td>
          <td>
              {{ item.amount }}
          </td>
          <td>
              <!-- {{ item.startSku }} -->
              {{ item.batchNum }}
          </td>
          <!-- <td>
              {{ item.goodsCode }}
          </td> -->
          <td>
              <div class="td_actions_ct">
                <a :href="item.downloadUrl">批量下载</a>
                <!-- <a class="td_action_btn" href="javascript:;" @click="start_edit(item)">修改</a>
                <a class="td_action_btn">删除</a> -->
              </div>
          </td>
        </tr>

      </table>

      <div class="no_data flex_center"  v-if="!query_configs.on_load && !query_configs.data.length">
        当前无记录
      </div>

      <page_foot 
      :total="query_configs.total_page" 
      :current="query_configs.params.pageNum"
      v-if="query_configs.total_page > 0"
      @select="select"
      ></page_foot>
      <br/>
      <br/>
    </div>

    <create_sku_code_form 
    :goods_id="goods_id" 
    v-if="create_sku_code_form_config.visible" 
    @close="visible('create_sku_code_form_config', false)"
    @success="add_sku_success"
    ></create_sku_code_form>
    <edit_product_form 
    v-if="edit_product_form_config.visible" 
    v-model="edit_product_form_config.data"
    @close="visible('edit_product_form_config', false)"
    ></edit_product_form>
  </div>
</template>
<script>
import create_sku_code_form from '@/modules/admins/product_manage/create_sku_code_form.vue'
import edit_product_form from '@/modules/admins/product_manage/edit_product_form.vue'
import img_show_dialog from '@/modules/admins/img_show_dialog.vue'

import page_foot from '@/modules/admins/page_foot.vue'

import {
  get_sku_page,
  get_sku_by_goodsid
} from '@/service'
import {
  get_token
} from '@/modules/stores'
export default {
  data () {
    return {
      create_sku_code_form_config: {
        visible: false
      },

      edit_product_form_config: {
        visible: false,
        data: null
      },

      query_configs: {
        on_load: false,
        total_page: 0,
        params: {
          'pageNum': 1,
          'total_page': 1,
          'userName': 'abc',
          'token': get_token()
        },
        data: [
        ],
        msg: ''
      }
    }
  },
  computed: {
    goods_id () {
      return this.$route.params.goods_id;
    },
    goods_code () {
      return this.$route.params.goods_code;
    },
    goods_name () {
      return this.$route.params.goods_name;
    }
  },
  mounted () {
    this.query();
  },
  methods: {
    visible (config, status){
      this[config].visible = status;
    },
    select (page) {
      this.query_configs.params.pageNum = page;
      this.query();
    },
    async query () {
      await this.query_page();

      this.query_configs.params.goodsId = parseInt(this.goods_id);

      this.query_configs.on_load = true;

      let data = await get_sku_by_goodsid(this.query_configs.params).catch(err => {
        this.query_configs.on_load = false;
      });

      let res = data.data || [];
      res.forEach(i => {
        if(i.time){
          i.time = i.time.split('.')[0];
        }
      });
      this.query_configs.data.splice(
        0, 
        this.query_configs.data.length, 
        ...(data.data || [])
      );

      this.query_configs.on_load = false;
    },
    async query_page () {
      let data = await get_sku_page(this.query_configs.params);
      this.query_configs.total_page = data.pageNum;
    },
    start_edit (item) {
      this.edit_product_form_config.data = item;
      this.visible('edit_product_form_config', true);
    },
    add_sku_success (item) {
      let index = this.query_configs.data.findIndex(i => i.batchNum == item.batchNum);
      if(index > -1){
        this.query_configs.data.splice(index, 1, item);
      }else{
        this.query_configs.data.unshift(item);
      }
      this.visible('edit_product_form_config', false);
      this.visible('create_sku_code_form_config', false);
    },
    show_img (index, status){
      this.query_configs.data[index].show_img = status;
      let item = this.query_configs.data[index];
      let data = this.query_configs.data.splice(index, 1, item);
    }
  },
  components: {
    create_sku_code_form,
    edit_product_form,
    img_show_dialog,
    page_foot
  }
}
</script>